
#include <fcntl.h>
#include "kapi.h"

int dev_fd;
#define MAX_SIZE 50

int my_kernel_func(int val, char* in_str, char *out_str){

    kfunc_t data;
    int ret_val;

    data.num = 3;
    
    data.arg[0].val = (void *)&val;
    data.arg[0].size = sizeof(int);
    data.arg[0].dir = DIR_IN;
    
    data.arg[1].val = (void *)in_str;
    data.arg[1].size = strlen(in_str) + 1;
    data.arg[1].dir = DIR_IN;

    data.arg[2].val = (void *)out_str;
    data.arg[2].size = MAX_SIZE;
    data.arg[2].dir = DIR_OUT;

    data.ret.val = (void *)&ret_val;
    data.ret.size = sizeof(int);
    data.ret.dir = DIR_OUT;

    if (ioctl(dev_fd, MY_KERNEL_FUNC, (void *)&data) < 0){
       perror("ioctl failed");
       return -1;
    }

    return ret_val;
}

int main(){

    char out[MAX_SIZE];
    int ret;

    dev_fd = open("/dev/kapi", O_RDONLY, 0666);

    if (dev_fd < 0){
        perror("open failed");
        return 0;
    }

    ret = my_kernel_func(10, "Hello Kernel World", out);

    printf("result = %d, out_str = %s\n", ret, out);
}

