/*Linux  fork.c */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>

int main(int argc, char *argv[])
{
  pid_t pid;
  /*
   * When fork returns -1, implies fork failed no child process
   * created pid of child process in parent's thread of execution 
   * 0 in child's thread of execution
   */
  if ((pid = fork()) < 0) {
    printf("Fork() failed\n");
    exit(1);
  }else if (pid != 0) {
    /* Parent code */
    printf("%s:Parent exiting.\n",argv[0]);
    exit(0);
  }
  /* Child code */
  printf("Starting child...:%s\n",argv[0]);
  while (1) {
    sleep(5);
    printf("%s:...Child running\n",argv[0]);
  }
}
